#import "as_controller.h"
#include <Carbon/Carbon.h>

@implementation as_controller

- (BOOL)exec_AS_handler:(NSString *)script_name the_handler:(NSString *)handler_name parameter_string:(NSString *)parameters_as_string {
	//This method will load an AppleScript and call a specific handler from that script with the specified string parameter. Other parameters and parameter types can be added but it was easier for me to simply use a single string and then have the handler in AppleScript parse that string into whatever data it actually needs (numbers, lists, booleans, etc.).
	
	//Reference:
	//http://lists.apple.com/archives/cocoa-dev/2003/Mar/02/addingapplescriptstudios.002.txt
	//username: archives password: archives
	NSAppleScript *my_script;
	NSAppleEventDescriptor *event;
	NSAppleEventDescriptor *target_address;
	NSAppleEventDescriptor *subroutine_descriptor;
	NSAppleEventDescriptor *arguments;
	NSAppleEventDescriptor *result;
	NSDictionary *my_error_dict = nil;
	NSDictionary *the_error;
	NSString *the_compiled_script;
	NSURL *the_URL;
	int pid = [[NSProcessInfo processInfo] processIdentifier];
	
	the_compiled_script=[[NSBundle mainBundle] pathForResource:script_name ofType:@"scpt" inDirectory:@"Scripts"];
	the_error=[NSDictionary dictionary];
	the_URL=[[NSURL alloc] initFileURLWithPath:the_compiled_script];
	my_script=[[NSAppleScript alloc] initWithContentsOfURL:the_URL error:&the_error];
	target_address=[[NSAppleEventDescriptor alloc] initWithDescriptorType:typeKernelProcessID bytes:&pid length:sizeof(pid)];
	event=[[NSAppleEventDescriptor alloc] initWithEventClass:kASAppleScriptSuite eventID:kASSubroutineEvent targetDescriptor:target_address returnID:kAutoGenerateReturnID transactionID:kAnyTransactionID];
	subroutine_descriptor=[NSAppleEventDescriptor descriptorWithString:handler_name];
	[event setParamDescriptor:subroutine_descriptor forKeyword:keyASSubroutineName];
	arguments=[[NSAppleEventDescriptor alloc] initListDescriptor];
	[arguments insertDescriptor:[NSAppleEventDescriptor descriptorWithString:parameters_as_string] atIndex:0];
	[event setParamDescriptor:arguments forKeyword:keyDirectObject];
	result=[my_script executeAppleEvent:event error:&my_error_dict];
	
	[the_URL release];
	[target_address release];
	[my_script release];
	[event release];
	[arguments release];
	return YES;
}

@end